function Map(linkItems) {   
    this.current = undefined;   
    this._size = 0;   
    if(linkItems === false){  
        this.disableLinking();   
    }   
}  
/** 
 * 获取当前map 
 * @return 当前对象 
 */  
Map.noop = function() {   
    return this;   
};   
/** 
 * 非法操作 
 * @return 
 */  
Map.illegal = function() {   
    throw new Error("非法操作，Map已经被禁用");   
};   
/** 
 *  
 * @param obj 
 * @param foreignKeys 
 * @return 
 */  
Map.from = function(obj, foreignKeys) {   
    var map = new Map;   
    for(var prop in obj) {   
        if(foreignKeys || obj.hasOwnProperty(prop)){  
            map.put(prop, obj[prop]);   
        }   
    }   
    return map;   
};   
/** 
 * 禁用map 
 * @return 
 */  
Map.prototype.disableLinking = function() {   
    this.link = Map.noop;   
    this.unlink = Map.noop;   
    this.disableLinking = Map.noop;   
    this.next = Map.illegal;   
    this.key = Map.illegal;   
    this.value = Map.illegal;   
    this.clear = Map.illegal;   
    return this;   
};   
/** 
 * 返回hash值 例如：number 123 
 * @param value key/value 
 * @return 
 */  
Map.prototype.hash = function(value) {   
    return (typeof value) + ' ' + (value instanceof Object ? (value.__hash || (value.__hash = ++arguments.callee.current)) : value.toString());   
};   
/** 
 * 返回map的长度 
 * @return 
 */  
Map.prototype.size = function() {   
    return this._size;  
};   
  
Map.prototype.hash.current = 0;   
/** 
 * 通过key获取value 
 * @param key 
 * @return 
 */  
Map.prototype.get = function(key) {   
    var item = this[this.hash(key)];   
    return item === undefined ? undefined : item.value;   
};   
/** 
 * 向map中添加数据 
 * @param key 键 
 * @param value 值 
 * @return 
 */  
Map.prototype.put = function(key, value) {   
    var hash = this.hash(key);   
    if(this[hash] === undefined) {   
        var item = { key : key, value : value };   
        this[hash] = item;   
        this.link(item);   
        ++this._size;   
    }else{  
        this[hash].value = value;  
    }   
    return this;   
};   
/** 
 * 通过key删除数据 
 * @param key 
 * @return 
 */  
Map.prototype.remove = function(key) {   
    var hash = this.hash(key);   
    var item = this[hash];   
    if(item !== undefined) {   
        --this._size;   
        this.unlink(item);   
        delete this[hash];   
    }   
    return this;   
};   
/** 
 * 清除map 
 * @return 
 */  
Map.prototype.clear = function() {   
    while(this._size){  
        this.remove(this.key());   
    }   
    return this;   
};   
/** 
 * 处理队列 
 * @param item 
 * @return 
 */  
Map.prototype.link = function(item) {   
    if(this._size == 0) {   
        item.prev = item;   
        item.next = item;   
        this.current = item;   
    }else {   
        item.prev = this.current.prev;   
        item.prev.next = item;   
        item.next = this.current;   
        this.current.prev = item;  
    }   
};   
Map.prototype.unlink = function(item) {   
    if(this._size == 0){   
        this.current = undefined;  
    }else {   
        item.prev.next = item.next;   
        item.next.prev = item.prev;   
        if(item === this.current){  
            this.current = item.next;   
        }   
    }   
};   
/** 
 * 获取下一个 
 * @return 
 */  
Map.prototype.next = function() {   
    this.current = this.current.next;   
    return this;  
};   
/** 
 * 获取key 
 * @return 
 */  
Map.prototype.key = function() {   
    return this.current.key;   
};   
/** 
 * 获取value 
 * @return 
 */  
Map.prototype.value = function() {   
    return this.current.value;   
};   

//ltx 左上点经度 minLng 最小经度  
//lty 左上点纬度 maxLat 最大纬度   
//rbx 右下点经度  maxLng 最大经度 
//rby 右下点纬度  minLat 最小纬度
//row 行
//col 列
//vdeviceData 传入的摄像头数据
//defaultPoint 传入的默认打点数
function mapShowByXY(ltx,lty,rbx,rby,row,col,vdeviceData,status){
	//经度
	var longitude  = 0; 
	//纬度
	var latitude  = 0;
	//接受的摄像头List
	var vdeviceList = new Array();  
	var vdeviceOnLineList = new Array();
	var vdeviceUnLineList = new Array();
	//返回值
	var result = {}; 
	//格子map
	var cell = new Map(); 
	/*
	//不需要默认处理了
	//如果defaultPoint为空 为其赋值100
	if(defaultPoint==null||defaultPoint==""||defaultPoint==undefined||defaultPoint=="null"){
		defaultPoint = 100;
	}
	*/
	//try {
		//行的一单位格子
		var cardinalx = (rbx-ltx)/row;
		//列的一单位格子
		var cardinaly = (lty-rby)/col; 
		//摄像头数量
		var vdeviceNum = 0 ; 
		var tmpVdeviceData = null;		
		for (var i=0;i<vdeviceData.length;i++ ){			
			tmpVdeviceData = vdeviceData[i];						
			longitude = tmpVdeviceData.longitude;
			latitude  = tmpVdeviceData.latitude;
			//判断是否在范围内
			if(longitude>=ltx && longitude<=rbx && latitude>=rby && latitude<=lty){
				vdeviceNum++; 
				vdeviceList.push(tmpVdeviceData);
				/*
				//全不显示
				if(status == 0){
					break;
				}
				//全显示 
				if(status == 1){
					
				}
				//在线显示，不在线不显示
				if(status == 2||tmpVdeviceData.isOnline==1){
					vdeviceOnLineList.push(tmpVdeviceData);
					continue;
				}
				//在线不显示，不在线显示
				if(status == 3||tmpVdeviceData.isOnline==0){
					vdeviceUnLineList.push(tmpVdeviceData);
					continue;
				}				
				*/
				//传入摄像头所在行
				row = parseInt((longitude - ltx) / cardinalx)+1; 
				//传入摄像头所在列
				col = parseInt((latitude - rby) / cardinaly )+1;  
				if(cell.get(row+""+col)==null||cell.get(row+""+col)==""||cell.get(row+""+col)==undefined||cell.get(row+""+col)=="null"){
					var tmp = {};
					tmp.count = 1;
					tmp.vdChannelId = tmpVdeviceData.vdChannelId;
					tmp.longitude = longitude;
					tmp.latitude = latitude;
					tmp.list = new Array();
					tmp.list.push(tmpVdeviceData);
					cell.put(row+""+col,tmp);
				}else{
					var tmp = cell.get(row+""+col);
					tmp.count = parseInt(tmp.count)+1;
					//alert("=tmp.list="+tmp.list);
					tmp.list.push(tmpVdeviceData);
					cell.put(row+""+col,tmp);
				}
			}else{
				//不在范围内
			}
		}
		//当范围内的数量少于默认数时，不存在格子
		if(vdeviceNum == 0){
			result.showMap = new Map();
		}else{
			result.showMap = cell;
		}
		result.showList = vdeviceList;
		//result.vdeviceOnLineList = vdeviceOnLineList;
		//result.vdeviceUnLineList = vdeviceUnLineList;
	//} catch(e){
		
	//}	
	return result;	
}
//ltx 左上点经度 minLng 最小经度  
//lty 左上点纬度 maxLat 最大纬度   
//rbx 右下点经度  maxLng 最大经度 
//rby 右下点纬度  minLat 最小纬度
//row 行
//col 列
//vdeviceData 传入的摄像头数据
//defaultPoint 传入的默认打点数
function mapShowCaseByXY(ltx,lty,rbx,rby,row,col,vdeviceData,status){
	//经度
	var longitude  = 0; 
	//纬度
	var latitude  = 0;
	//接受的摄像头List
	var vdeviceList = new Array();  
	var vdeviceOnLineList = new Array();
	var vdeviceUnLineList = new Array();
	//返回值
	var result = {}; 
	//格子map
	var cell = new Map(); 
	/*
	//不需要默认处理了
	//如果defaultPoint为空 为其赋值100
	if(defaultPoint==null||defaultPoint==""||defaultPoint==undefined||defaultPoint=="null"){
		defaultPoint = 100;
	}
	*/
	//try {
		//行的一单位格子
		var cardinalx = (rbx-ltx)/row;
		//列的一单位格子
		var cardinaly = (lty-rby)/col; 
		//摄像头数量
		var vdeviceNum = 0 ; 
		var tmpVdeviceData = null;		
		for (var i=0;i<vdeviceData.length;i++ ){			
			tmpVdeviceData = vdeviceData[i];						
			longitude = tmpVdeviceData.longitude;
			latitude  = tmpVdeviceData.latitude;
			//判断是否在范围内
			if(longitude>=ltx && longitude<=rbx && latitude>=rby && latitude<=lty){
				vdeviceNum++; 
				vdeviceList.push(tmpVdeviceData);
				/*
				//全不显示
				if(status == 0){
					break;
				}
				//全显示 
				if(status == 1){
					
				}
				//在线显示，不在线不显示
				if(status == 2||tmpVdeviceData.isOnline==1){
					vdeviceOnLineList.push(tmpVdeviceData);
					continue;
				}
				//在线不显示，不在线显示
				if(status == 3||tmpVdeviceData.isOnline==0){
					vdeviceUnLineList.push(tmpVdeviceData);
					continue;
				}				
				*/
				//传入摄像头所在行
				row = parseInt((longitude - ltx) / cardinalx)+1; 
				//传入摄像头所在列
				col = parseInt((latitude - rby) / cardinaly )+1;  
				if(cell.get(row+""+col)==null||cell.get(row+""+col)==""||cell.get(row+""+col)==undefined||cell.get(row+""+col)=="null"){
					var tmp = {};
					tmp.count = 1;
					tmp.vdChannelId = tmpVdeviceData.caseId;
					tmp.caseId = tmpVdeviceData.caseId;
					tmp.longitude = longitude;
					tmp.latitude = latitude;
					tmp.list = new Array();
					tmp.list.push(tmpVdeviceData);
					cell.put(row+""+col,tmp);
				}else{
					var tmp = cell.get(row+""+col);
					tmp.count = parseInt(tmp.count)+1;
					//alert("=tmp.list="+tmp.list);
					tmp.list.push(tmpVdeviceData);
					cell.put(row+""+col,tmp);
				}
			}else{
				//不在范围内
			}
		}
		//当范围内的数量少于默认数时，不存在格子
		if(vdeviceNum == 0){
			result.showMap = new Map();
		}else{
			result.showMap = cell;
		}
		result.showList = vdeviceList;
		//result.vdeviceOnLineList = vdeviceOnLineList;
		//result.vdeviceUnLineList = vdeviceUnLineList;
	//} catch(e){
		
	//}	
	return result;	
}